{$A+,B-,D+,E-,F+,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
uses crt,graph,strings,mouse,grtext;
const
 ch=4; { Horizontal size }
 cv=4; { Vertical size   }
 Shift=5;
 MaxMoves=100;
 FontType=1;
 FontSize=3;
 MenuItemsCount=6;
 MenuItems:array[1..MenuItemsCount] of string[20]=(
            'Move: ','New game','One more try','Hint','Help','Quit');
 MenuHelp:array[0..MenuItemsCount] of PChar=(
   ' '#0+
   'Use left button'#0+
   'of mouse to'#0+
   'turn the switch'#0#0,

   ' '#0+
   'Moves counter'#0+
   'Click it to'#0+
   'undo the move'#0#0,

   ' '#0' '#0+
   'Play with'#0+
   'new pattern'#0#0,

   ' '#0+
   'Try to win'#0+
   'this pattern'#0+
   'one more time'#0#0,

   ' '#0+
   'Click this'#0+
   'if you don''t'#0+
   'know, how to'#0+
   'win'#0#0,

   ' '#0' '#0+
   'Click this'#0+
   'to get help'#0#0,

   ' '#0' '#0+
   'Quit game'#0#0);

 QuitAllowed:boolean=false;
 HelpText:PChar=
   ' '#0+
   'This game was written using'#0+
   'Borland Pascal 7.0'#0+
   'in February of 2000 by (censored).'#0+
   ' '#0+
   'The matter of game -'#0+
   'to set all of the switches'#0+
   'in horizontal state.'#0+
   ' '#0' '#0+
   'Good luck!'#0#0;
type
 PWord = ^word;
 TState=(ver,hor);
 String80=string[80];

 PButton      = ^TButton;
 PBox         = ^TBox;
 PTextWindow  = ^TTextWindow;
 PMenuHelp    = ^TMenuHelp;
 PMenu        = ^TMenu;
 PHinter      = ^THinter;
 PGameField   = ^TGameField;
 PScrollBar   = ^TScrollBar;

 TScrollBar = object
               x,y:integer;
               SizeX,SizeY:integer;
               Owner:pointer;
               Value:word;
               MaxValue:word;
               DnButt,UpButt:PButton;
               constructor Init(iOwner:pointer; ix,iy,iSizeX,iSizeY:integer;
                                 iValue,iMaxValue:word);
               procedure ReDraw;
               destructor Done;
              end;{TScrollBar}
 TTextWindow = object
                x,y:integer;
                SizeX,SizeY:integer;
                Text:array[1..32] of PChar;
                Lines:integer;
                CurLine:integer;
                WinLines:byte;
                Owner:pointer;
                dy,y0,x0:integer;
                Height:word;
                SaveBack:boolean;
                ScrollBar:PScrollBar;
                Header:string80;
                CloseWinButt:PButton;
                MItems:TSetOfMouseItems;
                Font : record
                        Num:byte;
                        Size:byte;
                       end;
                SW:array[1..4] of record
                                   x1,y1,x2,y2:integer;
                                   Size:word;
                                   p:pointer;
                                  end;
                constructor Init(iOwner:pointer; ix,iy,iSizeX,iSizeY:integer;
                                  iFontNum,iFontSize:byte; iHeader:string80;
                                  iText:PChar; iSaveBack,iScrollBar:boolean);
                procedure Run;
                procedure ReDraw;
                destructor Done;
               end;{TTextWindow}
 TButton = object
            x,y:integer;
            SizeX,SizeY:byte;
            Pressed:boolean;
            Caption:string;
            MouseItemNum:byte; {Mouse item,assotiated with this button}
            Owner:pointer;
            Active:boolean;
            c:byte;
            constructor Init(iOwner:pointer; ix,iy:integer; iSizeX,iSizeY:byte;
                             ic:byte; iCaption:string);
            procedure ReDraw;
            destructor Done;
           end;{TButton}

 TBox = object(TButton)
         State:TState;
         Checked:boolean;
         constructor Init(iOwner:pointer; ix,iy,iSizeX,iSizeY:integer; iState:TState);
         procedure ReDraw;
         procedure ButtPressed;
         procedure ButtReleased;
         procedure ChangeState;
        end;{TBox}

 TMenuHelp = object(TTextWindow)
              d:byte;
              Context:byte;
              constructor Init(iOwner:pointer; ix,iy,iSizeX,iSizeY:integer);
              procedure ReDraw;
              destructor Done;
             end;{TMenuHelp}

 TMenu = object
          x,y:integer;
          SizeX,SizeY:integer;
          Move:PWord;
          Item:array[1..MenuItemsCount] of PButton;
          Help:PMenuHelp;
          Owner:pointer;
          HelpWindow:PTextWindow;
          MItems:TSetOfMouseItems;
          constructor Init(iOwner:pointer; ix,iy,iSizeX,iSizeY:integer; MovesPtr:PWord);
          procedure ReDraw;
          procedure Activate(i:byte);
          destructor Done;
         end;{TMenu}
 THinter = object
            sm:array [1..ch*cv] of byte;
            smCount:byte;
            Owner:pointer;
            constructor Init(iOwner:pointer);
            procedure GetHint(var xh,yh:byte);
            destructor Done;
           end;{THinter}
 TGameField = object
               x,y:integer;
               SizeX,SizeY:integer;
               LastMove:record x,y:byte end;
               Box:array[1..ch,1..cv] of PBox;
               Moves:array[1..MaxMoves] of byte;
               MovesPtr:word;
               Menu:PMenu;
               Hinter:PHinter;
               MItems:TSetOfMouseItems;
               FontPtr:pointer;
               FontFileSize:longint;
               constructor Init(ix,iy:integer; iSizeX,iSizeY:integer);
               procedure NewGame;
               procedure Idle;
               procedure ReDraw;
               procedure Clicked(rx,ry:byte);
               procedure GetHint(var xh,yh:byte);
               procedure ClearHints;
               function  WinPattern:boolean;
               procedure UndoMove;
               procedure Run;
               destructor Done;
              end;{TGameField}


 procedure TRipFont; external; {$L trip.obj}

 function XY_to_I(x,y:byte):byte;
 begin
  XY_to_I:=(y-1)*ch + x;
 end;{XY_to_I}

 procedure I_to_XY(i:byte; var x,y:byte);
 begin
  y:=(i-1) div ch + 1;
  x:=i-ch*(y-1);
 end;{I_to_X}

 constructor TScrollBar.Init(iOwner:pointer; ix,iy,iSizeX,iSizeY:integer;
                  iValue,iMaxValue:word);
 begin
  x:=ix; y:=iy; SizeX:=iSizeX; SizeY:=iSizeY;
  Owner:=iOwner; Value:=iValue; MaxValue:=iMaxValue;
  New(DnButt,Init(@Self,x,y+SizeY-SizeX,SizeX,SizeX,1,''));
  New(UpButt,Init(@Self,x,y,SizeX,SizeX,1,''));
{  ReDraw;}
  {Init mouse items}
 end;{TScrollBar.Init}

 procedure TScrollBar.ReDraw;
 begin
  SetFillStyle(SolidFill,LightBlue);  Bar(x,y,x+SizeX,y+SizeY);
  DnButt^.ReDraw;  UpButt^.ReDraw;
 end;{TScrollBar.ReDraw}

 destructor TScrollBar.Done;
 begin
  Dispose(UpButt,Done);
  dec(NMouseItem);
  Dispose(DnButt,Done);
  dec(NMouseItem);
  {Delete mouse items}
 end;{TScroller.Done}

 constructor TTextWindow.Init(iOwner:pointer; ix,iy,iSizeX,iSizeY:integer;
                              iFontNum,iFontSize:byte; iHeader:string80;
                              iText:PChar; iSaveBack,iScrollBar:boolean);
 label lab1;
 const d=7;
 var
  i:word;
  s:char;
  vp:ViewPortType;
 begin
  x:=ix; y:=iy; SizeX:=iSizeX; SizeY:=iSizeY;
  Font.Num:=iFontNum;  Font.Size:=iFontSize;
  Header:=iHeader;  MItems:=[];
  Owner:=iOwner; SaveBack:=iSaveBack;
  if not SaveBack then goto lab1;
  with sw[1] do begin
    x1:=x;                y1:=y;
    x2:=(SizeX div 2)+x;  y2:=(SizeY div 2)+y;
   end;
  with sw[2] do begin
    x1:=(SizeX div 2)+x;  y1:=y;
    x2:=x+SizeX;          y2:=(SizeY div 2)+y;
   end;
  with sw[3] do begin
    x1:=x;                y1:=(SizeY div 2)+y;
    x2:=(SizeX div 2)+x;  y2:=y+SizeY;
   end;
  with sw[4] do begin
    x1:=(SizeX div 2)+x;  y1:=(SizeY div 2)+y;
    x2:=x+SizeX;          y2:=y+SizeY;
   end;
  HideMouse;
  for i:=1 to 4 do with sw[i] do
   begin
    Size:=ImageSize(x1,y1,x2,y2);
    if GraphResult=grOk then
     begin
      GetMem(p,Size);
      GetImage(x1,y1,x2,y2,p^);
     end{if}
    else p:=nil;
   end;{for i}

 lab1:
  SetTextStyle(Font.Num,HorizDir,Font.Size);

  Height:=TextHeight('A');
  for s:='B' to '' do
   if TextHeight(s)>Height then
    Height:=TextHeight(s);

  HideMouse;
  SetFillStyle(SolidFill,blue);  Bar(x,y,x+SizeX,y+SizeY);
  SetLineStyle(SolidLn,$FFFF,ThickWidth);  SetColor(white);
  rectangle(x+1,y+1,x+SizeX-1,y+SizeY-1);  SetColor(LightGray);
  line(x+SizeX-1,y+1,x+SizeX-1,y+SizeY-1);
  line(x+1,y+SizeY-1,x+SizeX-1,y+SizeY-1);
{  SetColor(LightGray);
  rectangle(x+dx,y+dy,x+SizeX-dx,y+SizeY-dy);   SetColor(white);
  line(x+SizeX-dx,y+dy,x+SizeX-dx,y+SizeY-dy);
  line(x+dx,y+SizeY-dy,x+SizeX-dx,y+SizeY-dy);}
  if Header<>'' then
   begin
    SetFillStyle(SolidFill,LightBlue);  Bar(x+3,y+3,x+SizeX-3,y+round(1.5*Height)-3);
    SetLineStyle(SolidLn,$FFFF,ThickWidth);  SetColor(white);
    rectangle(x+1,y+1,x+SizeX-1,y+round(1.5*Height));  SetColor(LightGray);
    line(x+SizeX-1,y+1,x+SizeX-1,y+round(1.5*Height));
{    line(x+1,y+round(1.5*Height),x+SizeX-1,y+round(1.5*Height));}

    SetTextJustify(CenterText,CenterText);
    SetTextStyle(Font.Num,HorizDir,Font.Size);
    GetViewSettings(vp);
    SetViewPort(x+1,y+1,x+SizeX-1,y+round(1.5*Height),ClipOn);
    SetColor(white);
    OutTextXY(SizeX div 2,round(1.5*Height/2)-3,Header);
    with vp do SetViewPort(x1,y1,x2,y2,Clip);
    New(CloseWinButt,Init(@Self,x+SizeX-round(1.5*Height),y,
                          round(1.5*Height),round(1.5*Height),1,'X'));
    y:=y+round(1.5*Height);
    SizeY:=SizeY-round(1.5*Height);
   end;{if}

  y0:=(Height div 2)+3;
  x0:=(SizeX-2*1) div 2;
  dy:=round(Height*1.3);
  WinLines:=(SizeY-y0) div dy;

  i:=0;
  Lines:=1;
  Text[Lines]:=iText;
  CurLine:=1;
  while iText[i]+iText[i+1]<>#0#0 do
   if iText[i]=#0 then
    begin
{     iText[i]:=#0;}
     inc(Lines);
     Text[Lines]:=addr(iText[i+1]);
     inc(i);
    end
   else
    inc(i);
{  Text[Lines]:=nil;}

{  dec(Lines);}
  if iScrollBar then
   New(ScrollBar,Init(@Self,x+SizeX-18,y+3,15,SizeY-6,1,Lines-WinLines))
  else
   ScrollBar:=nil;

  ReDraw;
  ShowMouse;
 end;{TTextWindow.Init}

 procedure TTextWindow.Run;
 var c:byte;
 begin
  repeat
   while not (KeyPressed or MousePressed) do ;
   if KeyPressed then
    begin
     c:=ord(ReadKey);
     case c of
      27: break;
      0 : begin
            c:=ord(readkey);
            case c of
             72{Up}: if CurLine>1 then
                        begin
                         CurLine:=CurLine-1{byte(CurLine>1)};
                         ReDraw;
                        end;
             80{Dn}: if CurLine<=(Lines-WinLines) then
                       begin
                        CurLine:=CurLine+1{byte(CurLine<=Lines-WinLines)};
                        ReDraw;
                       end;
            end;{case}
           end;{#0}
     end;{case}
    end {if KeyPressed}
   else
    begin
     c:=ord(ReadMouse);
     if (ScrollBar<>nil) then
      if (c = ScrollBar^.UpButt^.MouseItemNum) then {Up button of scrollbar}
       begin
        ScrollBar^.UpButt^.Pressed:=true;
        ScrollBar^.ReDraw;
        if CurLine>1 then begin
          CurLine:=CurLine-1{byte(CurLine>1)};
          ReDraw;
        end;{if CurLine>1}
        while MousePressed do ;
        ScrollBar^.UpButt^.Pressed:=false;
        ScrollBar^.ReDraw;
       end {Up button of scrollbar}
      else
      if (c = ScrollBar^.DnButt^.MouseItemNum) then {Down button of scrollbar}
       begin
        ScrollBar^.DnButt^.Pressed:=true;
        ScrollBar^.ReDraw;
        if CurLine<=(Lines-WinLines) then begin
          CurLine:=CurLine+1{byte(CurLine<=Lines-WinLines)};
          ReDraw;
        end;{if CurLine}
        while MousePressed do ;
        ScrollBar^.DnButt^.Pressed:=false;
        ScrollBar^.ReDraw;
       end; {Down button of scrollbar}
     if (Header<>'') and (c = CloseWinButt^.MouseItemNum) then
      begin
       CloseWinButt^.Pressed:=true;
       CloseWinButt^.ReDraw;
       break;
      end;{Window events}
    end;{if MousePressed else}
   while MousePressed do ;  while keypressed do readkey;
  until false;
 end;{TTextWindow.Run}

 procedure TTextWindow.ReDraw;
 var
  vp:ViewPortType;
  i:word;
 begin
  HideMouse;
  SetTextJustify(CenterText,CenterText);
  SetTextStyle(Font.Num,HorizDir,Font.Size);
  GetViewSettings(vp);

  SetFillStyle(SolidFill,blue);
  if ScrollBar<>nil then
    begin
     bar(x+3,y+3,x+SizeX-4-ScrollBar^.SizeX,y+SizeY-3);
     ScrollBar^.ReDraw;
     SetViewPort(x+1,y+1,x+SizeX-ScrollBar^.SizeX-3,y+SizeY-3,ClipOn);
    end
  else
    begin
     bar(x+3,y+3,x+SizeX-3,y+SizeY-3);
     SetViewPort(x+1,y+1,x+SizeX-1,y+SizeY-1,ClipOn);
    end;{if}

  SetColor(white);
  for i:=CurLine to Lines do
   if (Text[i]<>nil) and (y0+dy*(i-CurLine)<=SizeY) then
    OutTextXY(x0,y0+dy*(i-CurLine),StrPas(Text[i]))
   else
    break;

  with vp do SetViewPort(x1,y1,x2,y2,Clip);
  ShowMouse;
 end;{TTextWindow.ReDraw}

 destructor TTextWindow.Done;
 var i:byte;
 begin
  HideMouse;
  if ScrollBar<>nil then Dispose(ScrollBar,Done);
  if Header<>'' then Dispose(CloseWinButt,Done);
{  DisposeMouseItems(MItems);}
{  SetFillStyle(SolidFill,black);
  Bar(sw[1].x1,sw[1].y1,sw[4].x2,sw[4].y2);}
  for i:=1 to 4 do with sw[i] do
   if p<>nil then
     begin
      PutImage(x1,y1, p^, NormalPut);
      FreeMem(p,Size);
      p:=nil;
     end;{if}
  ShowMouse;
 end;{TTextWindow.Done}

 constructor TButton.Init(iOwner:pointer; ix,iy:integer; iSizeX,iSizeY:byte; ic:byte; iCaption:string);
 var
  mi:MouseItemType;
 begin
  x:=ix; y:=iy; SizeX:=iSizeX; SizeY:=iSizeY;
  Caption:=iCaption; Pressed:=false;
  Owner:=iOwner; c:=ic;  Active:=false;

  MouseItemNum:=NextFreeMouseItem;

  with mi do begin
   x1:=x; y1:=y; x2:=x+SizeX; y2:=y+SizeY;
   key:=MouseItemNum;
   Butt:=AnyButton;
  end;{with}
  AddMouseItem(mi);

  ReDraw;
 end;{TButton.Init}

 procedure TButton.ReDraw;
 var
  x0,y0:byte;
  vp:ViewPortType;
  ts:TextSettingsType;
  dx,dy:byte;
 begin
  HideMouse;
  SetFillStyle(SolidFill,blue);  bar(x,y,x+SizeX,y+SizeY);
  SetLineStyle(SolidLn,$FFFF,NormWidth);
  setcolor(white);  rectangle(x,y,x+SizeX,y+SizeY);
  x0:=SizeX div 2;  y0:=SizeY div 2;
  if Pressed then
   begin
    SetLineStyle(SolidLn,$FFFF,ThickWidth); setcolor(lightgray);
    rectangle(x+c,y+c,x+SizeX-c,y+SizeY-c); setcolor(white);
    line(x+SizeX-c,y+c,x+SizeX-c,y+SizeY-c);
    line(x+c,y+SizeY-c,x+SizeX-c,y+SizeY-c);

    SetColor(DarkGray); SetLineStyle(SolidLn,$FFFF,NormWidth);
{    line(x+c,y+c,x+SizeX-c,y+c);
    line(x+c,y+c,x+c,y+SizeY-c);}
    line(x+c,y+c-1,x+SizeX-c,y+c-1);
    line(x+c-1,y+c,x+c-1,y+SizeY-c);
   end
  else
   begin
    SetLineStyle(SolidLn,$FFFF,ThickWidth); setcolor(White);
    rectangle(x+c,y+c,x+SizeX-c,y+SizeY-c); setcolor(LightGray);
    line(x+SizeX-c,y+c,x+SizeX-c,y+SizeY-c);
    line(x+c,y+SizeY-c,x+SizeX-c,y+SizeY-c);
    SetColor(DarkGray); SetLineStyle(SolidLn,$FFFF,NormWidth);
{    line(x+SizeX-c,y+c,x+SizeX-c,y+SizeY-c);
    line(x+c,y+SizeY-c,x+SizeX-c,y+SizeY-c);}
    line(x+SizeX-c+1,y+c,x+SizeX-c+1,y+SizeY-c);
    line(x+c,y+SizeY-c+1,x+SizeX-c,y+SizeY-c+1);
   end;{if Pressed}
  if Active then
   begin
    SetColor(magenta);
    SetLineStyle(CenterLn,$FFFF,NormWidth);
    rectangle(x+c,y+c,x+SizeX-c,y+SizeY-c);
    rectangle(x+c+1,y+c+1,x+SizeX-c-1,y+SizeY-c-1);
   end;{if}
  GetViewSettings(vp);  GetTextSettings(ts);
  SetTextStyle(FontType,HorizDir,FontSize);
  SetTextJustify(CenterText,CenterText);
  SetViewPort(x+c,y+c,x+SizeX-c,y+SizeY-c,ClipOn); SetColor(white);
  OutTextXY((SizeX-2*c) div 2,(SizeY-2*c) div 2 -3,Caption);
  with ts do begin
   SetTextStyle(Font,Direction,CharSize);
   SetTextJustify(Horiz,Vert);
  end;
  with vp do SetViewPort(x1,y1,x2,y2,Clip);
  ShowMouse;
 end;{TButton.ReDraw}

 destructor TButton.Done;
 begin
  exclude(MouseItemsInUse, MouseItemNum);
 end;{TButton.Done}

 constructor TBox.Init(iOwner:pointer; ix,iy,iSizeX,iSizeY:integer; iState:TState);
 begin
  inherited Init(iOwner, ix,iy,iSizeX,iSizeY,Shift,'');
  {x:=ix;  y:=iy;  SizeX:=iSizeX;  SizeY:=iSizeY;}
  State:=iState;
  ReDraw;
 end;{TBox.Init}

 procedure TBox.ButtPressed;
{ const  ddx=8; ddy=8; dx=4; dy=3; c=5;
 var x0,y0:integer; }
 begin
  Pressed:=true;
  ChangeState;
  ReDraw;
 end;{TBox.Pressed}

 procedure TBox.ButtReleased;
 begin
  Pressed:=false;
  ReDraw;
 end;{TBox.Released}

 procedure TBox.ReDraw;
 const  ddx=8; ddy=8; dx=4; dy=3;
 var
  x0,y0:integer;
 begin
  inherited ReDraw;
  x0:=SizeX div 2;
  y0:=SizeY div 2;

  HideMouse;
  SetFillStyle(SolidFill,green);
  case State of
   hor : bar(x+ddx,y+y0-dy,x+SizeX-ddx,y+y0+dy);
   ver : bar(x+x0-dx,y+ddy,x+x0+dx,y+SizeY-ddy);
  end;{case}
  ShowMouse;
 end;{TBox.ReDraw}

 procedure TBox.ChangeState;
 begin
  if State=ver then  State:=hor  else  State:=ver;
 end;{TBox.ChangeState}

 constructor TMenu.Init(iOwner:pointer; ix,iy,iSizeX,iSizeY:integer; MovesPtr:PWord);
 var
  dy:integer;
  i:byte;
  mi:MouseItemType;
 begin
  x:=ix; y:=iy; SizeX:=iSizeX; SizeY:=iSizeY;
  Owner:=iOwner;  MItems:=[];
  Move:=MovesPtr;
  dy:=SizeY div MenuItemsCount;
  for i:=1 to MenuItemsCount do
   New(Item[i],Init(@Self, x,y+dy*(i-1),SizeX,dy,Shift,MenuItems[i]));
  New(Help,Init(@Self, x,y+dy*MenuItemsCount,SizeX,GetMaxY-(y+dy*MenuItemsCount)-3));
  ReDraw;
 end;{TMenu.Init}

 procedure TMenu.Activate(i:byte);
 const
  z=36;
  LastHint:byte=0;
 var
  s:string;
  j,k:byte;
  xh,yh:byte;
 begin
  Item[i]^.Pressed:=true;
  Item[i]^.ReDraw;
  case i of
   1: {Moves counter}
     begin
      PGameField(Owner)^.UndoMove;
      str(Move^,s);
      Item[i]^.Caption:=MenuItems[i]+s;
      Item[i]^.ReDraw;
     end; {Moves counter}
   2: {New game}
     begin
      PGameField(Owner)^.NewGame;
     end; {New game}
   3: {One more try}
     begin
      while Move^>0 do
       begin
        PGameField(Owner)^.UndoMove;
{        str(Move^,s);
        Item[1].Caption:=MenuItems[1]+s;
        Item[1].ReDraw;}
       end;
      ReDraw;
     end; {One more try}
   4: {Hint}
     begin
      if LastHint<>0 then
       begin
        I_to_XY(LastHint,xh,yh);
        PGameField(Owner)^.Box[xh,yh]^.Active:=false;
        PGameField(Owner)^.Box[xh,yh]^.ReDraw;
       end;
      PGameField(Owner)^.GetHint(xh,yh);
      LastHint:=XY_to_I(xh,yh);
      PGameField(Owner)^.Box[xh,yh]^.Active:=true;
      PGameField(Owner)^.Box[xh,yh]^.ReDraw;
     end;{Hint}
   5: {Help}
     begin
      New(HelpWindow,Init(@Self, z,z,x-2-2*z,GetMaxY-2-2*z,FontType,2,'Help',HelpText,true,false));
      HelpWindow^.Run;
      Dispose(HelpWindow,Done);
     end; {Help}
   6: {Quit}
     begin
      QuitAllowed:=true;
     end; {Quit}
  end;{case}
  while MousePressed do;
  Item[i]^.Pressed:=false;
  Item[i]^.ReDraw;
 end;{TMenu.Activate}

 procedure TMenu.ReDraw;
 var
  i:byte;
  s:string[10];
 begin
  str(Move^,s);
  Item[1]^.Caption:=MenuItems[1]+s;
  for i:=1 to MenuItemsCount do
   Item[i]^.ReDraw;
  Help^.ReDraw;
 end;{TMenu.ReDraw}

 destructor TMenu.Done;
 var i:byte;
 begin
  for i:=1 to MenuItemsCount do
   Dispose(Item[i],Done);
  Dispose(Help,Done);
  DisposeMouseItems(MItems);
 end;{TMenu.Done}

 constructor TMenuHelp.Init(iOwner:pointer; ix,iy:integer; iSizeX,iSizeY:integer);
 begin
  d:=5;
  Context:=0;
  inherited Init(iOwner,ix,iy,iSizeX,iSizeY,1,2,'',MenuHelp[Context],false,false);
{  WinLines:=6;}
{  HideMouse;
  SetFillStyle(SolidFill,blue);  bar(x+1,y+1,x+SizeX-1,y+SizeY+1);
  SetLineStyle(SolidLn,$FFFF,NormWidth);
  setcolor(white);  rectangle(x,y,x+SizeX,y+SizeY);
  SetLineStyle(SolidLn,$FFFF,ThickWidth); setcolor(white);
  rectangle(x+d,y+d,x+SizeX-d,y+SizeY-d);
  ReDraw;
  ShowMouse;}
 end;{TMenuHelp.Init}

 procedure TMenuHelp.ReDraw;
 const
  LastContext:byte=255;
 var
  vp:ViewPortType;
  ts:TextSettingsType;
  i:byte;
 begin
  Context:=0;
  for i:=1 to MenuItemsCount do
   with PMenu(Owner)^.Item[i]^ do
    if MouseIn(x,y,x+SizeX,y+SizeY) then
     begin
      Context:=i;
      break;
     end;{for}
  if LastContext=Context then
   exit;
  LastContext:=Context;

  i:=0;
  Lines:=1;
  Text[Lines]:=MenuHelp[Context];
  CurLine:=1;
  while MenuHelp[Context][i]+MenuHelp[Context][i+1]<>#0#0 do
   if MenuHelp[Context][i]=#0 then
    begin
{     MenuHelp[Context][i]:=#0;}
     inc(Lines);
     Text[Lines]:=addr(MenuHelp[Context][i+1]);
     inc(i);
    end
   else
    inc(i);
{  Text[Lines]:=nil;
  dec(Lines);}

  inherited ReDraw;
{  Text:=MenuHelp[Context];
  inherited ReDraw;
  HideMouse;
  GetViewSettings(vp);  GetTextSettings(ts);
  SetTextStyle(FontType,HorizDir,FontSize);
  SetTextJustify(CenterText,CenterText);
  SetFillStyle(SolidFill,blue);
  bar(x+d+1,y+d+1,x+SizeX-d-1,y+SizeY-d-1);
  SetViewPort(x+d,y+d,x+SizeX-d,y+SizeY-d,ClipOn);
  SetColor(white);

  OutTextXY((SizeX-2*d) div 2,(SizeY-2*d) div 2-3,MenuHelp[Context]);

  with ts do begin
   SetTextStyle(Font,Direction,CharSize);
   SetTextJustify(Horiz,Vert);
  end;
  with vp do SetViewPort(x1,y1,x2,y2,Clip);
  ShowMouse;}
 end;{TMenuHelp.ReDraw}

 destructor TMenuHelp.Done;
 begin
 end;{TMenuHelp.Done}

 constructor THinter.Init(iOwner:pointer);
 var i,j:byte;
 begin
  Owner:=iOwner;
  smCount:=0;
  for j:=1 to cv do
   for i:=1 to ch do
    if PGameField(Owner)^.Box[i,j]^.State=ver then
      begin
       inc(smCount);
       sm[smCount]:=XY_to_I(i,j);
      end;{if}
 end;{THinter.Init}

 procedure THinter.GetHint(var xh,yh:byte);
 var i,j:byte;
 begin
  if smCount<0 then smCount:=0;
  if smCount=0 then
   for j:=1 to cv do
    for i:=1 to ch do
     if PGameField(Owner)^.Box[i,j]^.State=ver then
       begin
        inc(smCount);
        sm[smCount]:=XY_to_I(i,j);
       end;{if}
  I_to_XY(sm[smCount],xh,yh);
  dec(smCount);
 end;{THinter.GetHint}

 destructor THinter.Done;
 begin
 end;{THinter.Done}

 constructor TGameField.Init(ix,iy:integer; iSizeX,iSizeY:integer);
 const  c=20;  FontHeight=19;
 var
  i,j:byte;
  sx,sy:byte;
  f:file;
  FontHeightStr:string;
  BoxMouseItem:MouseItemType;
 begin
  x:=ix;  y:=iy;  SizeX:=iSizeX;  SizeY:=iSizeY;
  LastMove.x:=0;
  LastMove.y:=0;
  MovesPtr:=0;
  for i:=1 to MaxMoves do
    Moves[i]:=0;
  Randomize;

  str(FontHeight,FontHeightStr);
  assign(f,'8x'+FontHeightStr+'.fnt');
  {$I-}
  reset(f,1);
  {$I+}
  if IOResult<>0 then
   begin
    CloseGraph;
    writeln(#7,' Can''t find font file 8x',FontHeightStr,'.fnt');
    while keypressed do readkey;
    readkey;
    halt(2);
   end;{if}
  FontFileSize:=FileSize(f);
  GetMem(FontPtr,FontFileSize);
  blockread(f,FontPtr^,FontFileSize);
  close(f);
  SetFont(FontPtr,8,FontHeight);
  GraphWriteOn;
  if not IsMouse then
   begin
    TextBackGround(red);
    textColor(white);
    SetWindow(28,10,62,14,DoubleBorder,' Error ',true,true,false);
    writeln(' This program require a mouse.');
    write(#10#13'      Press any key to quit.');
    while keypressed do readkey;
    readkey;
    GraphWriteOff;
    CloseGraph;
    halt(1);
   end;{if}
  TextRatioY:=FontHeight;
  InitMouse;

  sx:=SizeX div ch;
  sy:=SizeY div cv;

  SetFillStyle(SolidFill,DarkGray);
  bar(0,0,GetMaxX,GetMaxY);
  SetFillStyle(SolidFill,black);
  bar(x+c,y-c,x+SizeX+c,y+SizeY-c);

{  SetFillStyle(SolidFill,darkgray);
  bar(x,y,x+SizeX,y+SizeY);}
  for j:=1 to cv do
   for i:=1 to ch do
    New(Box[i,j],Init(@Self,x+sx*(i-1),y+sy*(j-1),sx,sy,TState(random(2))));

  New(Menu,Init(@Self,450,0,(getmaxx-450),320,@MovesPtr));
  New(Hinter,Init(@Self));
 end;{TGameField.Init}

 procedure TGameField.NewGame;
 var i,j:byte;
 begin
  LastMove.x:=0;
  LastMove.y:=0;
  MovesPtr:=0;
  ClearHints;
  for i:=1 to MaxMoves do  Moves[i]:=0;
  Randomize;

  for j:=1 to cv do
   for i:=1 to ch do
    Box[i,j]^.State:=TState(random(2));
  ReDraw;
 end;{TGameField.NewGame}

 procedure TGameField.Idle;
 begin
  Menu^.Help^.ReDraw;
 end;{TGameField.Idle}

 procedure TGameField.ReDraw;
 var i,j:byte;
 begin
  for j:=1 to cv do
   for i:=1 to ch do
    Box[i,j]^.ReDraw;
{  MovesCounter.ReDraw(MovesPtr);}
  Menu^.ReDraw;
 end;{TGameField.ReDraw}

 procedure TGameField.Clicked(rx,ry:byte);
 var i,j:byte;
 begin
{  Box[rx,ry].ChangeState;
  Box[rx,ry].ReDraw;}
  for j:=1 to cv do
   begin
    if j=ry then continue;
    Box[rx,j]^.ChangeState;
    Box[rx,j]^.ReDraw;
   end;
  for i:=1 to ch do
   begin
    if i=rx then continue;
    Box[i,ry]^.ChangeState;
    Box[i,ry]^.ReDraw;
   end;
 end;{TGameField.Clicked}

 procedure TGameField.GetHint(var xh,yh:byte);
 begin
  Hinter^.GetHint(xh,yh);
 end;{TGameField.GetHint}

 procedure TGameField.ClearHints;
 var i,j:byte;
 begin
  for j:=1 to cv do
   for i:=1 to ch do
    if Box[i,j]^.Active then
     begin
      Box[i,j]^.Active:=false;
      Box[i,j]^.ReDraw;
      break;
     end;
 end;{ClearHint}

 function TGameField.WinPattern:boolean;
 var i,j:byte;
 begin
  WinPattern:=true;
  for j:=1 to cv do
   for i:=1 to ch do
    if Box[i,j]^.State<>hor then
     begin
      WinPattern:=false;
      break;
     end;{if}
 end;{WinPattern}

 procedure TGameField.UndoMove;
 begin
  if MovesPtr<1 then
   begin sound(400); delay(150); nosound; end
  else
   begin
    I_to_XY(Moves[MovesPtr],LastMove.x,LastMove.y);
    dec(MovesPtr);
    Box[LastMove.x,LastMove.y]^.ChangeState;
    Box[LastMove.x,LastMove.y]^.ReDraw;
    Clicked(LastMove.x,LastMove.y);
   end;{if}
 end;{TGameField.UndoMove}

 procedure TGameField.Run;
 const
  t:PChar= ' '#0+
           'You are trying too long time.'#0+
           'Leave it game and try again'#0+
           'some time later.'#0+
           ' '#0+
           'Press ESC to quit.'#0#0;
  WinText= ' '#0+
           'You win this pattern!'#0+
           'You are the great gamer!'#0#0;
  z=50;
 var
  c:byte;
  rx,ry:byte;
  i,j:byte;
  w:PTextWindow;
 begin
  ShowMouse;
  repeat
   while not (KeyPressed or MousePressed) do Idle;
   if KeyPressed then
    begin
     c:=ord(ReadKey);
     case c of
      27 {ESC} : QuitAllowed:=true;
      8 {BkSp} : UndoMove;
     end;{case}
    end {if KeyPressed}
   else
    begin
     c:=ord(ReadMouse);
     if c in [1..ch*cv] then {Boxes events}
      begin
       MovesPtr:=MovesPtr+1;    Moves[MovesPtr]:=c;
       I_to_XY(c,LastMove.x,LastMove.y);
       Box[LastMove.x,LastMove.y]^.ButtPressed;
       sound(800); delay(20); nosound;
       Clicked(LastMove.x,LastMove.y);
       Menu^.ReDraw;
       while MousePressed do ;
       Box[LastMove.x,LastMove.y]^.ButtReleased;
       ClearHints;
       if MovesPtr>=MaxMoves then
        begin
         New(w,Init(@Self,z,3*z,Menu^.x-2-2*z,(GetMaxY div 2)-z,7,1,'Sorry...',t, true,false));
         w^.Run;
         Dispose(w,Done);
         Menu^.ReDraw;
         QuitAllowed:=true;
        end;{if}
      end;{Boxes events}
     if c in [ch*cv+1..ch*cv+MenuItemsCount] then {Menu events}
      begin
       Menu^.Activate(c-ch*cv);
      end;{Menu events}
    end;{if MousePressed else}
   while MousePressed do ;  while keypressed do readkey;
   if WinPattern then
    begin
     New(w,Init(@Self,z,3*z,Menu^.x-2-2*z,(GetMaxY div 2)-2*z,7,1,'COOL-COOL-COOL!',WinText, true,false));
     w^.Run;
     Dispose(w,Done);
     NewGame;
    end;{if}
  until QuitAllowed;
 end;{TGameField.Run}

 destructor TGameField.Done;
 var i,j:byte;
 begin
  for j:=1 to cv do
   for i:=1 to ch do
    Dispose(Box[i,j],Done);
  Dispose(Menu,Done);
  Dispose(Hinter,Done);
  DisposeMouseItems(MItems);

  HideMouse;
  FreeMem(FontPtr,FontFileSize);
  GraphWriteOff;
 end;{TGameField.Done}

var
 GameField:TGameField;
 gd,gm,err:integer;
begin
 gd:=Detect;
{ gm:=VGAhi;}
 InitGraph(gd,gm,'d:\lang\tp\bgi');
{ SetGraphMode(gm-1);}
 err:=GraphResult;
 if err<>grOk then
  begin
   writeln('Graph error: ',GraphErrorMsg(err));
   halt(1);
  end;
 ClearDevice;
 GameField.Init(70, 70, ch*70, cv*70);
 GameField.Run;
 GameField.Done;
{ CloseGraph;}
end.