uses crt,graph,mouse;
const
 CooBegX:integer=100;
 CooBegY:integer=20;
 DX:integer=60;
 DY:integer=30;
 Sl:integer=20;
 Sh:integer=3;
 Out:boolean=false;
var
 Movies:array[1..4096] of byte;
 PAr:array[1..4,1..4] of boolean;
 PW:array[1..16] of byte absolute PAr;
 Field:array[1..17] of MouseItemType;
 gd,gm,er:integer;
 CurrentMove:word;
 i,j,x,y:byte;


procedure ResetPole;
var
 i,j:byte;
begin
 randomize;
 for i:=1 to 4 do
  for j:=1 to 4 do
   if random(3)>1 then
    PAr[i,j]:=true
   else
    PAr[i,j]:=false;
end;{ResetPole}

procedure SetMouseItems;
var
 i,x,y:byte;
begin
 for i:=1 to 16 do
  with Field[i] do
   begin
    y:=(i-1) div 4+1;
    x:=i-(y-1)*4-1;
    dec(y);
    x1:=CooBegX+dx*x;
    x2:=CooBegX+dx*(x+1);
    y1:=CooBegY+dy*y;
    y2:=CooBegY+dy*(y+1);
    Butt:=1;
    Key:=i;
   end;{with Field[i]}
  with Field[17] do
   begin
    x1:=0;
    y1:=0;
    x2:=GetMaxx;
    y2:=getmaxy;
    butt:=2;
    key:=17;
   end;
end;{SetMouseItems}

function RightResult:boolean;
var
 i,j:byte;
begin
 rightresult:=true;
 for i:=1 to 4 do
  for j:=1 to 4 do
   if not PAr[i,j] then
    RightResult:=false;
end;{RightResult}

procedure ShowMoveCounter;
var
 OldPort:ViewPortType;
 s:string[5];
begin
 GetViewSettings(OldPort);
 rectangle(CooBegX+DX*4+20,CooBegY,CooBegX+DX*4+91,CooBegY+11);
 SetViewPort(CooBegX+DX*4+21,CooBegY+1,CooBegX+DX*4+90,CooBegY+10,clipoff);
 ClearViewPort;
 settextjustify(CenterText,CenterText);
 settextstyle(2,0,4);
 SetUserCharSize(2,1,1,1);
 str(CurrentMove,s);
 outtextxy(35,3,s);
 with OldPort do
  SetViewPort(x1,y1,x2,y2,Clip);
end;{ShowMoveCounter}

procedure ReDrawPole;
var
 ddx,ddy:integer;
 i,j:byte;
procedure DrawHorizontal(i,j:integer);
begin
 dec(i);
 dec(j);
 Rectangle(CooBegX+ddx+dx*i-(SL div 2),CooBegY+ddy+dy*j-(Sh div 2),
            CooBegX+ddx+dx*i+(SL div 2),CooBegY+ddy+dy*j+(Sh div 2));
end;{DrawHorizontal}
procedure DrawVertical(i,j:integer);
begin
 dec(i);
 dec(j);
 Rectangle(CooBegX+ddx+dx*i-(Sh div 2),CooBegY+ddy+dy*j-(SL div 2),
            CooBegX+ddx+dx*i+(Sh div 2),CooBegY+ddy+dy*j+(SL div 2));
end;{DrawVertical}
begin
 HideMouse;
 ClearDevice;
 for i:=0 to 4 do
  line(CooBegX,DY*i+CooBegY,DX*4+CooBegX,DY*i+CooBegY);
 for i:=0 to 4 do
  line(CooBegX+DX*i,CooBegY,CooBegX+DX*i,CooBegY+DY*4);
 ddx:=dx div 2;
 ddy:=dy div 2;
 for i:=1 to 4 do
  for j:=1 to 4 do
   begin
    if PAr[i,j]=true then
     begin {horizontal}
      DrawHorizontal(j,i);
     end
    else
     begin {vertical}
      DrawVertical(j,i);
     end;{if}
   end;{for}
 ShowMoveCounter;
end;{ReDrawPole}

procedure Turn(k:byte);
begin
 y:=(k-1) div 4+1;
 x:=k-(y-1)*4;
 par[y,x]:=not(par[y,x]);
 for k:=1 to 4 do
  begin
   par[k,x]:=not(par[k,x]);
   par[y,k]:=not(par[y,k]);
  end;{for}
end;{Turn}

begin {main}
 if not InitMouse then
  begin
   writeln('This program need a mouse!');
   halt;
  end;
 gd:=cga;
 gm:=CGAhi;
 initgraph(gd,gm,'c:\lang\tp\bgi');
 Er:=GraphResult;
 if Er<>0 then
  begin
   writeln(GraphErrorMsg(er));
   halt;
  end;
 resetpole;
 ReDrawPole;
 SetMouseItems;
 MouseWindow(CooBegX,CooBegY,CooBegX+DX*4,CooBegY+DY*4);
 MouseGotoXY((DX*4 div 2)+CooBegX,(DY*4 div 2)+CooBegY);
 SetMouseItem(17,Field);
 settextjustify(CenterText,CenterText);
 Settextstyle(2,0,8);
 CurrentMove:=1;
 ShowMoveCounter;
 ShowMouse;
 while true do
  begin
    while not MousePressed do
    if keypressed then
     if (readkey=#8) then
      begin
       if not(CurrentMove>1) then
        begin
         sound(1000);
         delay(10);
         nosound;
         continue;
        end;
       dec(CurrentMove);
       turn(Movies[CurrentMove]);
       ReDrawPole;
       ShowMouse;
       while keypressed do readkey;
       continue;
      end
     else
      halt;
    while MousePressed do ;
    i:=ord(ReadMouse);
    if i=17 then
     begin
      hidemouse;
      cleardevice;
      settextjustify(CenterText,CenterText);
      Settextstyle(2,0,8);
      outtextxy(getmaxx div 2,getmaxy div 2,'Do you really want to quit?');
      case readkey of
      'Y','y',#13:halt;
      'N','n',#27:begin
                   cleardevice;
                   ReDrawPole;
                   ShowMouse;
                  end;
      end;{case}
      continue;
     end;
    Movies[CurrentMove]:=i;
    inc(CurrentMove);
    if i=0 then
     if (readkey=#8) then
      begin
       if not(CurrentMove>1) then
        begin
         sound(1000);
         delay(10);
         nosound;
         continue;
        end;
       dec(CurrentMove);
       turn(Movies[CurrentMove-1]);
       dec(CurrentMove);
       ReDrawPole;
       ShowMouse;
       while keypressed do readkey;
       continue;
      end
     else
      halt;
    sound(1000);
    delay(5);
    nosound;
    Turn(i);
    ReDrawPole;
    ShowMouse;
    if RightResult then
     begin
      HideMouse;
      while MousePressed do
       if keypressed then
        break;
      ReadKeyOrMouse;
      cleardevice;
      settextstyle(7,0,5);
      outtextxy(getmaxx div 2,getmaxy div 2,'You win!');
      while MousePressed do
       if keypressed then
        halt;
      ReadKeyOrMouse;
      halt;
     end;{if}
  end;
end.