unit Mouse;

{============================} INTERFACE {===================================}

type
 MouseItemType=record
  x1,y1,x2,y2:integer;{न }
  Butt:word;{᫮ 맮}
  Key:word;{- }
 end;

type
 MouseHandlerType=procedure(mask,buttons,x,y,dx,dy:integer);
 TMouseState=record
              butt:word;
              x,y:word;
             end;
const
 LeftButton=1;
 RightButton=2;
 CenterButton=4;
 AnyButton=7;{ }

{樥  㠫 न  ⥪⮢}
const
 TextRatioX:byte=8;
 TextRatioY:byte=8;

{樠 }

function IsMouse:boolean;
{True, ᫨  㯭}

function InitMouse:boolean;
{樠 }

procedure SetMousePage(page:byte);
{⠭ ࠭  㪠⥫ }

function GetMousePage:byte;

procedure SetStepToPixel(hor,ver:integer);
{⠭ ⢨⥫쭮 }

procedure GetStepToPixel(hor,ver:integer);
{頥 ⢨⥫쭮 }

procedure SetDoubleSpeed(speed:word);
{ண 㤢 }

function GetDoubleSpeed:word;

{न}

function MouseTextCooX(x:integer):byte;
{- ⥪. न  㠫쭮}

function MouseTextCooY(y:integer):byte;
{- ⥪. न  㠫쭮}

function MouseGraphCooX(x:byte):integer;

function MouseGraphCooY(y:byte):integer;

procedure MouseWhereXY(var x,y:integer);
{- . न }

procedure MouseGotoXY(x,y:integer);

function MouseWhereX:byte;

function MouseWhereY:byte;

function MouseIn(x1,y1,x2,y2:integer):boolean;
{True, ᫨ 㪠⥫   -}

{ﭨ }

function NumButton:byte;
{-  }

procedure GetMouseState(var State:TMouseState);
{ﭨ }

function MousePressed:boolean;
{True, ᫨   }

procedure MouseButtPressed(butt:integer;var stat,count,x,y:integer);
{- .  ⮩ :
BUTT-䫠 롮 
STAT-. ;
COUNT-- ⨩,
X,Y-न}

procedure MouseButtReleased(butt:integer;var stat,count,x,y:integer);
{- .  ⮩ :
BUTT-䫠 롮 訦
STAT-. ;
COUNT-- ⨩,
X,Y-न}

{}

procedure mousewindow(x1,y1,x2,y2:integer);
procedure mousescreen;

{ଠ 㪠⥫}
procedure showmouse;
procedure hidemouse;
procedure mousetextcursor(scrmask,curmask:word);
procedure mouseblink(yup,ydn:byte);
procedure mousegraphcursor(var scrcurmask;x,y:byte);

{\ ﭨ}
function mousebuffsize:word;
procedure savemouse(var buff);
procedure restoremouse(var buff);

{ -}
procedure setmouseitem(nitem:byte;var items);
procedure addmouseitem(item:mouseitemtype);
procedure clearmouseitems;
procedure GetMouseItem(var nitem:byte;var items);
function KeyOrMousePressed:boolean;
function ReadKeyOrMouse:char;
function readmouse:char;

{ࠡ⪠ ᮡ⨩  }
procedure setmousehandler(mask:word;proc:mousehandlertype);
procedure changemousehandler(mask:word;proc:mousehandlertype;
                             var oldmask:word; var oldproc:pointer);
procedure clearmousehandler;

{============================} IMPLEMENTATION {==============================}

uses dos,crt;
type
 mouseitems=array[1..2*maxint div sizeof(mouseitemtype)] of mouseitemtype;
 pmouseit=^mouseitems;
const
 mousepresent:boolean=false;
 itemslist:pmouseit=nil;
 nmouseitem:byte=0;
 mousevisible:boolean=false;
 x1m:integer=0;
 y1m:integer=0;
 x2m:integer=639;
 y2m:integer=199;
 speed2:word=128;
 verrat:integer=8;
 horrat:integer=8;
 nbutton:byte=0;
var
 reg:registers;

{ -}

const
 doublechars:boolean=false;
var
 secchar:char;


function ismouse:boolean;
var
 p:pointer;
 k,x,y:integer;
 is:boolean;
begin
 if nbutton=0 then
  begin
   getintvec($33,p);
   is:=p<>nil;
   if is then with reg do
    begin
     ax:=$3;
     bx:=$FFFF;
     intr($33,reg);
     is:=bx<>$FFFF;
    end;
   mousepresent:=is;
  end;
 ismouse:=mousepresent
end;{ismouse}
function initmouse:boolean;
begin
 with reg do
  begin
   ax:=0;
   intr($33,reg);
   if ax=0 then
    mousepresent:=false
   else
    mousepresent:=true;
   nbutton:=bx
  end;
 clearmouseitems;
 setmousepage(0);
 hidemouse;
 mousescreen;
 initmouse:=mousepresent;
end;{initmouse}

procedure setmousepage(page:byte);
begin
 with reg do
  begin
   ax:=$1D;
   bl:=page;
   bh:=0;
   intr($33,reg)
  end;
end;{setmousepage}

function getmousepage:byte;
begin
 with reg do
  begin
   ax:=$1E;
   intr($33,reg);
   getmousepage:=bl;
  end;
end;{getmousepage}

procedure setsteptopixel(hor,ver:integer);
begin
 if ismouse then with reg do
  begin
   ax:=$0F;
   cx:=hor and $7FFF;
   dx:=ver and $7FFF;
   horrat:=cx;
   verrat:=dx;
   intr($33,reg);
  end;
end;{setsteptopixel}

procedure getsteptopixel(hor,ver:integer);
begin
 if ismouse then with reg do
  begin
   hor:=horrat;
   ver:=verrat;
  end;
end;

procedure setdoublespeed(speed:word);
begin
 if ismouse then with reg do
  begin
   ax:=$13;
   dx:=speed;
   speed2:=speed;
   intr($33,reg)
  end;
end;{setdoublespeed}

function getdoublespeed:word;
begin
 getdoublespeed:=speed2;
end;

{न}

function mousetextcoox(x:integer):byte;
begin
 mousetextcoox:=x div textratiox+1;
end;
function mousetextcooy(y:integer):byte;
begin
 mousetextcooy:=y div textratioy+1;
end;

function mousegraphcoox(x:byte):integer;
begin
 mousegraphcoox:=(x-1)*textratiox;
end;
function mousegraphcooy(y:byte):integer;
begin
 mousegraphcooy:=(y-1)*textratioy;
end;

procedure mousewherexy(var x,y:integer);
begin
 if ismouse then with reg do
  begin
   ax:=$3;
   intr($33,reg);
   x:=cx;
   y:=dx;
  end
 else
  begin
   x:=-1;
   y:=-1;
  end;
end;{mousewherexy}
procedure mousegotoxy(x,y:integer);
begin
 if ismouse then with reg do
  begin
   ax:=$4;
   cx:=x;
   dx:=y;
   intr($33,reg);
  end
end;{mousegotoxy}

function mousewherex:byte;
begin
 if ismouse then with reg do
  begin
   ax:=$3;
   intr($33,reg);
   mousewherex:=mousetextcoox(cx)
  end
 else
  mousewherex:=0
end;{mousewherex}
function mousewherey:byte;
begin
 if ismouse then with reg do
  begin
   ax:=$3;
   intr($33,reg);
   mousewherey:=mousetextcooy(dx)
  end
 else
  mousewherey:=0
end;{mousewherey}
function mousein(x1,y1,x2,y2:integer):boolean;
begin
 if ismouse then with reg do
  begin
   ax:=$3;
   intr($33,reg);
   mousein:=(cx>=x1) and (cx<=x2) and (dx>=y1) and (dx<=y2)
  end
 else
  mousein:=false
end;{mousein}

{ }

function numbutton:byte;
begin
 numbutton:=nbutton;
end;
procedure getmousestate(var State:TMouseState);
begin
 if ismouse then with reg do
  begin
   ax:=$3;
   intr($33,reg);
   state.butt:=bx;
   state.x:=cx;
   state.y:=dx;
  end
 else
  begin
   state.butt:=0;
   state.x:=0;
   state.y:=0;
  end;
end;{getmousestate}
function mousepressed:boolean;
var
 mp:boolean;
begin
 if ismouse then with reg do
  begin
   ax:=$3;
   intr($33,reg);
   mp:=bx<>0;
  end
 else
  mp:=false;
 mousepressed:=mp;
end;{mousepressed}
procedure mousebuttpressed(butt:integer;
              var stat,count,x,y:integer);
begin
 if ismouse then with reg do
  begin
   ax:=$5;
   bx:=butt;
   intr($33,reg);
   count:=bx;
   x:=cx;
   y:=dx;
   stat:=bx
  end
 else
  {*********************}
  exit;
  {*********************}
end;
procedure mousebuttreleased(butt:integer;
              var stat,count,x,y:integer);
begin
 if ismouse then with reg do
  begin
   ax:=$6;
   bx:=butt;
   intr($33,reg);
   count:=bx;
   x:=cx;
   y:=dx;
   stat:=bx
  end
 else
  {*********************}
  exit;
  {*********************}
end;
procedure mousewindow(x1,y1,x2,y2:integer);
begin
 if ismouse then
  begin
   x1m:=x1;
   y1m:=y1;
   x2m:=x2;
   y2m:=y2;
   with reg do
    begin
     ax:=$7;
     cx:=x1;
     dx:=x2;
     intr($33,reg);
     ax:=$8;
     cx:=y1;
     dx:=y2;
     intr($33,reg);
    end {with}
   end{if}
end;{mousewindow}
procedure mousescreen;
var
 x2,y2:integer;
begin
 if ismouse then with reg do
  begin
   ah:=$f;
   intr($10,reg);
   case al of
   1,4,5,13:begin
             x2:=319;
             y2:=199;
            end;
   15,16:begin
          x2:=639;
          y2:=349;
         end;
   17,18:begin
          x2:=639;
          y2:=479
         end
   else
    x2:=639;
    y2:=199
   end;{case}
  end;{if}
 mousewindow(0,0,x2,y2);
end;{mousescreen}

{ଠ 㪠⥫}

procedure showmouse;
begin
 if ismouse and not mousevisible then
  with reg do
   begin
    ax:=$1;
    intr($33,reg);
    mousevisible:=true;
   end
end;{showmouse}
procedure hidemouse;
begin
 if ismouse and mousevisible then
  with reg do
   begin
    ax:=$2;
    intr($33,reg);
    mousevisible:=false;
   end
end;{hidemouse}
procedure mousetextcursor(scrmask,curmask:word);
begin
 if ismouse then with reg do
  begin
   ax:=$a;
   bx:=0;
   cx:=scrmask;
   dx:=curmask;
   intr($33,reg);
  end;
end;
procedure mouseblink(yup,ydn:byte);
begin
 if ismouse then with reg do
  begin
   ax:=$a;
   bx:=1;
   cx:=yup;
   dx:=ydn;
   intr($33,reg);
  end
end;{mouseblink}
procedure mousegraphcursor(var scrcurmask;x,y:byte);
begin
 if ismouse then with reg do
  begin
   ax:=$3;
   bx:=x;
   cx:=y;
   es:=seg(scrcurmask);
   dx:=ofs(scrcurmask);
   intr($33,reg);
  end;
end;{mousegraphcursor}

{\ ﭨ}

function mousebuffsize:word;
begin
 if ismouse then with reg do
  begin
   ax:=$15;
   bx:=0;
   intr($33,reg);
   mousebuffsize:=bx
  end
 else
  mousebuffsize:=0
end;

procedure savemouse(var buff);
begin
 if ismouse then with reg do
  begin
   ax:=$16;
   es:=seg(buff);
   dx:=ofs(buff);
   intr($33,reg);
  end;
end;{savemouse}
procedure restoremouse(var buff);
begin
 if ismouse then with reg do
  begin
   ax:=$17;
   es:=seg(buff);
   dx:=ofs(buff);
   intr($33,reg);
  end;
end;{restoremouse}

procedure setmouseitem(nitem:byte;var items);
begin
 if ismouse then
  begin
   clearmouseitems;
   getmem(itemslist,nitem*sizeof(mouseitemtype));
   move(items,itemslist^,nitem*sizeof(mouseitemtype));
   nmouseitem:=nitem;
  end
end;{setmouseitem}

procedure addmouseitem(item:mouseitemtype);
var
 p:pmouseit;
 k:byte;
begin
 if ismouse then
  begin
   k:=nmouseitem;
   getmem(p,(k+1)*sizeof(mouseitemtype));
   move(itemslist^,p^,k*sizeof(mouseitemtype));
   clearmouseitems;
   nmouseitem:=k+1;
   itemslist:=p;
  end;
end;{addmouseitem}
procedure clearmouseitems;
begin
 if ismouse and (nmouseitem<>0) then
  begin
   freemem(itemslist,nmouseitem*sizeof(mouseitemtype));
   nmouseitem:=0;
  end
end;
procedure getmouseitem(var nitem:byte;var items);
begin
 if ismouse and (nmouseitem<>0) then
  begin
   nitem:=nmouseitem;
   move(itemslist^,items,nmouseitem*sizeof(mouseitemtype));
  end;
end;{getmouseitem)


{ࠡ⪠ ᮡ⨩  }

const
 olduserproc:pointer=nil;
var
 userproc:mousehandlertype absolute olduserproc;
 oldax:word;
procedure mousehandler; far; assembler;
asm
 push bp
 push ds
 push es
 push ax
 mov  ax,seg @data
 mov  ds,ax
 pop  ax
 mov  oldax,ax
 mov  ax,word ptr [olduserproc]
 or   ax,word ptr [olduserproc+2]
 jz   @
 mov  ax,oldax
 push ax
 push bx
 push cx
 push dx
 push di
 push si
 call [userproc]
@:pop es
 pop  ds
 pop  bp
 ret  far
end;{mousehandler}
procedure setmousehandler(mask:word;proc:mousehandlertype);
begin
 if ismouse then with reg do
  begin
   userproc:=proc;
   ax:=$0C;
   cx:=mask;
   es:=seg(mousehandler);
   dx:=ofs(mousehandler);
   intr($33,reg);
  end
end;{setmousehandler}

procedure changemousehandler(mask:word;proc:mousehandlertype;
                             var oldmask:word; var oldproc:pointer);

begin
 if ismouse then with reg do
  begin
   oldproc:=olduserproc;
   ax:=$14;
   cx:=mask;
   es:=seg(mousehandler);
   dx:=ofs(mousehandler);
   intr($33,reg);
   oldmask:=cx;
  end
end;{changemousehandler}
procedure clearmousehandler;
begin
 if ismouse then with reg do
  begin
   ax:=$0C;
   cx:=0;
   es:=0;
   dx:=0;
   intr($33,reg);
  end;
end;{clearmousehandler}

function keyormousepressed:boolean;
var
 b,k,bk:integer;
 mouseactive:boolean;
begin
 if keypressed then
  keyormousepressed:=true
 else with reg do
  begin
   ax:=$3;
   intr($33,reg);
   bk:=bx;
   if (bk<>0) and (nmouseitem<>0) then
    begin
     mouseactive:=false;
     for k:=1 to nmouseitem do
      if not mouseactive then
       with itemslist^[k] do
        begin
         case butt of
          leftbutton:b:=bk and leftbutton;
          rightbutton:b:=bk and rightbutton;
          centerbutton:b:=bk and centerbutton;
          anybutton:b:=bk
         else
          b:=0;
         end;{case}
         mouseactive:=(b<>0) and
                      mousein(mousegraphcoox(x1),mousegraphcooy(y1),
                              mousegraphcoox(x2),mousegraphcooy(y2));
        end;{for,if}
        keyormousepressed:=mouseactive
   end {if (bx<>) and ...}
   else
    keyormousepressed:=false;
  end;{with reg do}
end;{keyormousepressed}

function readkeyormouse:char;
var
 k:byte;
 b,bb:word;
 mouseactive:boolean;
label
 loop;
begin
 loop:
 if not ismouse or keypressed then
  readkeyormouse:=readkey
 else
  if doublechars then
   begin
    doublechars:=false;
    readkeyormouse:=secchar;
   end
  else if nmouseitem<>0 then with reg do
   begin
    mouseactive:=false;
    ax:=$3;
    intr($33,reg);
    bb:=bx;
    if bb<>0 then
     for k:=1 to nmouseitem do
      if not mouseactive then
       with itemslist^[k] do
        begin
         case butt of
          leftbutton:bb:=bx and leftbutton;
          rightbutton:bb:=bx and rightbutton;
          centerbutton:bb:=bx and centerbutton;
          anybutton:bb:=bx
         else
          bb:=0;
         end;
{         if (bb<>0) and mousein(
                       mousegraphcoox(x1),mousegraphcooy(y1),
                       mousegraphcoox(x2),mousegraphcooy(y2)) then}
         if (bb<>0) and mousein(x1,y1,x2,y2) then
          begin
           mouseactive:=true;
           readkeyormouse:=chr(lo(key));
           if lo(key)=0 then
            begin
             doublechars:=true;
             secchar:=chr(hi(key))
            end
          end
        end;{for... if not mouseactive}
       if not mouseactive then
        goto loop;
   end{if nmouseitem<>0}
  else
   readkeyormouse:=readkey
end;{readkeyormouse}
function readmouse:char;
var
 k:byte;
 b,bb:word;
 mouseactive:boolean;
label
 loop;
begin
 loop:
 if IsMouse then
  if doublechars then
   begin
    doublechars:=false;
    readmouse:=secchar;
   end
  else if nmouseitem<>0 then with reg do
   begin
    mouseactive:=false;
    ax:=$3;
    intr($33,reg);
    bb:=bx;
    if bb<>0 then
     for k:=1 to nmouseitem do
      if not mouseactive then
       with itemslist^[k] do
        begin
         case butt of
          leftbutton:bb:=bx and leftbutton;
          rightbutton:bb:=bx and rightbutton;
          centerbutton:bb:=bx and centerbutton;
          anybutton:bb:=bx
         else
          bb:=0;
         end;
{         if (bb<>0) and mousein(
                       mousegraphcoox(x1),mousegraphcooy(y1),
                       mousegraphcoox(x2),mousegraphcooy(y2)) then}
         if (bb<>0) and mousein(x1,y1,x2,y2) then
          begin
           mouseactive:=true;
           readmouse:=chr(lo(key));
           if lo(key)=0 then
            begin
             doublechars:=true;
             secchar:=chr(hi(key))
            end
          end
        end;{for... if not mouseactive}
       if keypressed then
        begin
         readmouse:=#0;
         exit;
        end;
       if not mouseactive then
        goto loop;
   end{if nmouseitem<>0}
end;{readmouse}
end.